<?php

/**
 * class pluginTemplate
 *
 *  A template to get you started building templates.  Rename all pluginTemplate
 *  with the name of your plugin
 *
 *
 *
 */
include_once(MODOSDATE_DIR . 'modPlugin.php');
require_once("functions.php");
require_once("requestRemote.php");

class topcmmFlashChat extends modPlugin {

	/**
   * Holds the language phrases
   *
   * @access private
   */
	var $lang;

	/**
   * Holds the user id
   *
   * @access private
   */
	var $uid;

	/**
   * Rating system ID
   *
   * @access private
   */
	var $rid;

	/**
   * Holds the rating system id
   *
   * @access private
   */
	var $lang_123flashchat_table = "123flashchat";

	/**
   * The name name of the plugin class.
   *
   * @access private
   */
	var $plugin_class_name = "topcmmFlashChat";

	/**
   * The text that appears in the admin plugin list
   *
   * @access private
   */
	var $display_name = '123 Flash Chat';

	/**
   * The link text that appears on the user's menu
   *
   * @access private
   */
	var $user_menu_text;

	/**
   * Appear on users menu (true or false)
   *
   * @access private
   */
	var $user_menu_appear = true;


	/**
   * The link text that appears on the admin's menu
   *
   * @access private
   */
	var $admin_menu_text ;

	/**
   * Appear on admin's menu (true or false)
   *
   * @access private
   */
	var $admin_menu_appear = true;

	/**
   * Constructor
   *
   * @return
   * @access public
   */
	function topcmmFlashChat( )
	{
		$this->modPlugin();
		$pluginDir = dirname(__FILE__).'/../';
		$this->lang = $this->modLoadLang($pluginDir);
		$this->user_menu_text=$this->lang['123flashchat']['123flashchat'];
		$this->display_name=$this->lang['123flashchat']['123flashchat'];
		$this->admin_menu_text=$this->lang['123flashchat']['setting'];		
	} // end of member method pluginClass

	/**
   * Does the processing to display a user page.  Called from plugin.php
   *
   * @return array
   * @access public
   */
	function  displayPluginPage() {
		$this->modSmartyAssign('lang',$this->modGetLang());
		$this->modSmartyAssign('plugin_name',$this->plugin_class_name);
		$chatSetting = $this->getChatConfig();	
		
		$udata = $this->modGetLoggedInUser();
		$user->username = $udata['username'];
		$user->password = $udata['password'];
		$user->fullname = $udata['firstname'].$udata['lastname'];
		$data['room'] = isset($_GET['room'])?$_GET['room']:'';	
			
		if($chatSetting->fc_extendserver == '2'){
			if($chatSetting->fc_fullscreen){
				echo chat_free($chatSetting,$user);
				exit;
			}else{
				$this->modSmartyAssign('showchat',chat_free($chatSetting,$user));
				$text=$this->modSmartyFetch('123flashchat.tpl');
				return $text;
			}
		}else{
			if($chatSetting->fc_fullscreen){
				echo chat_server($chatSetting,$user,$data);
				exit;
			}else{
				$this->modSmartyAssign('showchat',chat_server($chatSetting,$user,$data));
				$text=$this->modSmartyFetch('123flashchat.tpl');
				return $text;
			}
		}
	}
	/**
   * WARNING: USER IS NOT VALIDATED HERE.  BE CAREFUL
   * Does the processing to display 100% plugin content.  Called from pluginraw.php
   *
   * @return array
   * @access public
   */
	function  displayPluginContent() {
		$this->modSmartyAssign('lang',$this->modGetLang());
		$this->modSmartyAssign('plugin_name',$this->plugin_class_name);
		$udata = $this->modGetLoggedInUser();
		$this->uid=$udata['id'];
	}
	/**
   * Returns the content that will appear in the left column of a page.  Designed to be overridden by plugins
   *
   * @return array
   * @access public
   */
	function displayLeftCol() {
		if(isset($_SESSION['UserName'])){
			$this->modSmartyAssign('lang', $this->modGetLang() );
			$this->modSmartyAssign('chatstatus', serviceGetChatStats($this->getChatConfig()));
			return $this->modSmartyFetch('123flashchat_bar.tpl');
		}else{
			return false;
		}
	}
	/**
   * Returns the content that will appear in the main content area of the page.  This content will appear after the existing main content.  Designed to be overridden by plugins
   *
   * @return array
   * @access public
   */
	function displayMain() {

	}
	/**
   * Does the processing to display a admin page.  Called from plugin.php
   *
   * @return array
   * @access public
   */
	function  displayPluginAdminPage() {
		$this->modSmartyAssign('lang',$this->modGetLang());
		$this->modSmartyAssign('plugin_name',$this->plugin_class_name);
		$mod = isset($_GET['mod']) ? $_GET['mod'] : "chatsetting";
        
		$chatSetting = $GLOBALS['osDB']->getRow("SELECT * FROM ! WHERE id = 1",array(DB_PREFIX."_".$this->lang_123flashchat_table));
		$this->modSmartyAssign('data',$chatSetting);
		if($mod == "chatsetting"){
			if(isset($_POST['params'])){
				$errmessage = array();
				$data['fc_extendserver'] = isset($_POST['params']['fc_extendserver']) ? $_POST['params']['fc_extendserver'] : 2;
                $data['fc_servertype'] = isset($_POST['params']['fc_servertype']) ? $_POST['params']['fc_servertype'] : 0;          
                
				switch ($_POST['params']['fc_extendserver']){
					case "0":
                        $data['fc_client_loc'] = isset($_POST['params']['fc_client_loc']) ? ($_POST['params']['fc_client_loc'] . (substr($_POST['params']['fc_client_loc'],-1,1) != '/' ? '/' : '')) : '';
                        if($data['fc_client_loc']) {
                            
                            $serverinfo = $this->getServerHostPortLocal($data['fc_client_loc']);
                            $data['fc_server_host'] = !empty($_POST['params']['fc_server_host']) ? $_POST['params']['fc_server_host'] : (empty($serverinfo['fc_server_host']) ? $_SERVER['HTTP_HOST'] : $serverinfo['fc_server_host']) ;
                    		$data['fc_server_host_s'] = empty($serverinfo['fc_server_host_s']) ? $data['fc_server_host'] : $serverinfo['fc_server_host_s'];
                            $data['fc_server_host_h'] = empty($serverinfo['fc_server_host_h']) ? $data['fc_server_host'] : $serverinfo['fc_server_host_h']; 

                    		if(!is_numeric($_POST['params']['fc_server_port']) || strpos($_POST['params']['fc_server_port'] ,".")!==false){
                    			$data['fc_server_port'] = empty($serverinfo['fc_server_port']) ? ( $data['fc_servertype'] == 1 ? '51212' : '51127') : $serverinfo['fc_server_port'] ;
                    		}else{
                    			$data['fc_server_port'] = $_POST['params']['fc_server_port'];
                    		}
                            
                     		if(!is_numeric($_POST['params']['fc_server_port_h']) || strpos($_POST['params']['fc_server_port_h'] ,".")!==false){
                    			$data['fc_server_port_h'] = empty($serverinfo['fc_server_port_h']) ? ( $data['fc_servertype'] == 1 ? '31212' : '35555') : $serverinfo['fc_server_port_h'] ;
                    		}else{
                    			$data['fc_server_port_h'] = $_POST['params']['fc_server_port_h'];
                    		}   
                                                    
                     		$data['fc_server_port_s'] = empty($serverinfo['fc_server_port_s']) ? (  $data['fc_servertype'] == 1 ? '51213' : '51128') : $serverinfo['fc_server_port_s'] ;
                    		$data['fc_api_url'] = 'http://' . $data['fc_server_host'] . ':' . $data['fc_server_port_h'] . '/'; 
                                                                                  
                        } else {
                            
                            $data['fc_server_host'] = $_SERVER['HTTP_HOST'];
                    		$data['fc_server_host_h'] = $data['fc_server_host_s'] = $data['fc_server_host'];
                    		if($data['fc_servertype'] == 1){
                    			$data['fc_server_port_h'] = '31212';
                    			$data['fc_server_port_s'] = '51213';
                    			$data['fc_server_port']   = '51212';
                    		}else{
                    			$data['fc_server_port_h'] = '35555';
                    			$data['fc_server_port_s'] = '51128';
                    			$data['fc_server_port']   = '51127';
                    		}
                    		$data['fc_api_url'] = 'http://' . $data['fc_server_host'] . ':' . $data['fc_server_port_h'] . '/';
                    		$data['fc_client_loc'] = $data['fc_api_url'];
                                                        
                        }

                    	$s_own_loc = 1;
        	            $c_own_loc = 1;
        	            $da = 1;
        	            if($_POST['params']['fc_server_local']){
        	            	$c_own_loc = validate_client($data['fc_client_loc']);
                    		$da = validate_data_api($data['fc_api_url']  . 'online.js');
        		            if($c_own_loc || $da){
        	            		$errmessage[] = $this->lang['123flashchat']['server_port_or_location_incorrect'];
        	            	}
        	            }else{
        	            	$c_own_loc = validate_client($data['fc_client_loc']);
        	            	if($c_own_loc){
        	            		$errmessage[] = $this->lang['123flashchat']['server_port_or_location_incorrect'];
        	            	}
        	            }
                    	$check = validate_client('http://'.parse_url($data['fc_client_loc'], PHP_URL_HOST).':'.$data['fc_server_port_h'].'/');
                    	if($check){
                    		$errmessage[] = $this->lang['123flashchat']['client_location_incorrect'];
                    	}                        
                        
						break;
                        
					case "1":
						$data['fc_client_loc'] = isset($_POST['params']['fc_client_loc']) ? ($_POST['params']['fc_client_loc'] . (substr($_POST['params']['fc_client_loc'],-1,1) != '/' ? '/' : '')) : '';
						if($data['fc_client_loc']){
                            $serverinfo = $this->getServerHostPortHost($data['fc_client_loc']);
            				if($serverinfo){					
            					$data['fc_server_host']   = empty($serverinfo['fc_server_host']) ? parse_url($data['fc_client_loc'], PHP_URL_HOST) : $serverinfo['fc_server_host'];
            					$data['fc_server_host_s'] = empty($serverinfo['fc_server_host_s']) ? '' : $serverinfo['fc_server_host_s'];
            					$data['fc_server_host_h'] = empty($serverinfo['fc_server_host_h']) ? '' : $serverinfo['fc_server_host_h'];
            					$data['fc_server_port']   = empty($serverinfo['fc_server_port']) ? '' : $serverinfo['fc_server_port'];
            					$data['fc_server_port_h'] = empty($serverinfo['fc_server_port_h']) ? '' : $serverinfo['fc_server_port_h'];
                        		$data['fc_server_port_s'] = empty($serverinfo['fc_server_port_s']) ? '' : $serverinfo['fc_server_port_s'];
                        		$data['fc_api_url']       = 'http://' . $data['fc_server_host'] . '/';
                        		$data['fc_group']         = substr(parse_url($data['fc_client_loc'], PHP_URL_PATH),1,-1);
                                
            					$c_own_loc = validate_client($data['fc_client_loc']);
            					$da = validate_data_api($data['fc_api_url'] . 'online.js?group=' . $data['fc_group']);
            			        if($c_own_loc || $da){
            						$errmessage[] = $this->lang['123flashchat']['client_location_incorrect'];
            			        }
            				}else{
            				    $errmessage[] = $this->lang['123flashchat']['client_location_none'];
            				}						  
						}else{
							$errmessage[] = $this->lang['123flashchat']['client_location_none'];
						}
						break;
                        
					case "2":                 
                    
						$data['fc_room'] = $_POST['params']['fc_room'] ? $_POST['params']['fc_room'] : $_SERVER['HTTP_HOST'];
						break;
				}

        		if($data['fc_servertype'] == 1){
        			$data['fc_clienttype'] = 0;
        		}else{
        			$data['fc_clienttype'] = isset($_POST['params']['fc_clienttype']) ? $_POST['params']['fc_clienttype'] : 0;
        		}
                  
                if($_POST['params']['fc_fullscreen'] == 0) {
    				if(!is_numeric($_POST['params']['fc_client_width']) || !is_numeric($_POST['params']['fc_client_height'])){
    					$errmessage[] = $this->lang['123flashchat']['client_size_is_not_right'];
    				}
                }
				
				if($errmessage){	//has error ,show errors
					$message['status'] = 'error';
					$message['message'] = $errmessage;
				}else{
					$data['fc_room_list'] = isset($_POST['params']['fc_room_list']) ? $_POST['params']['fc_room_list'] : 0;
					$data['fc_user_list'] = isset($_POST['params']['fc_user_list']) ? $_POST['params']['fc_user_list'] : 0;
					$data['fc_client_width'] = $_POST['params']['fc_client_width'];
					$data['fc_client_height'] = $_POST['params']['fc_client_height'];
					$data['fc_fullscreen'] = $_POST['params']['fc_fullscreen'];				
					$data['fc_client_lang'] = $_POST['params']['fc_client_lang'] ? $_POST['params']['fc_client_lang'] : 'auto';
					$data['fc_client_skin'] = $_POST['params']['fc_client_skin'] ? $_POST['params']['fc_client_skin'] : 'default';
					
					//update database 123flashchat_setting
					$updateset = '';
					foreach($data as $key => $value){
						if($updateset){
							$updateset .= ', ' . $key . ' = "' . $value . '" ';
						}else{
							$updateset .= $key . ' = "' . $value . '" ';
						}
					}
                    
					if($this->modEditRec($this->lang_123flashchat_table,$data,array('id' => 1))){
						$message['status'] = 'success';
						$message['message'] = $this->lang['123flashchat']['update_setting_success'];
					}else{
						$errmessage[] = $this->lang['123flashchat']['update_setting_failed'];
						$message['status'] = 'error';
						$message['message'] = $errmessage;
					}
				}	
                $this->modSmartyAssign('message',$message);		
			}
            
            $chatvalid = getValid($chatSetting) ? "1" : "0";
			$this->modSmartyAssign('chatvalid',$chatvalid);
			return $this->modSmartyFetch("admin/chatsetting.tpl");
		}else{
			if($chatSetting['fc_extendserver'] != 2){
				$chat_admin_url = $chatSetting['fc_client_loc']."admin_123flashchat.swf?init_host=". 
					$chatSetting['fc_server_host'] ."&init_port=" . $chatSetting['fc_server_port'] . 
					(($chatSetting['fc_extendserver'] == "1") ? ("&init_group=" . $chatSetting['fc_group']) : "");
				$this->modSmartyAssign('chat_admin_url',$chat_admin_url);
			}
			return $this->modSmartyFetch("admin/adminpanel.tpl");
		}		

	}
	
	function getChatConfig(){
		$chatSetting = $GLOBALS['osDB']->getRow("SELECT * FROM ! WHERE id = 1",array(DB_PREFIX."_".$this->lang_123flashchat_table));
		return (object)$chatSetting;
	}
    
    public function getServerHostPortLocal($client_location){
		$content = topcmmRequestRemote::requestRemote($client_location.'htmlchat/config/config.js',1);
		if ($content){
			//server host
		 	preg_match('/init_host = "([a-zA-Z0-9.]*)";/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host'] = $matches[1];			        	
	        }else{
		        preg_match('/init_host="([a-zA-Z0-9.]*)";/', $content, $matches);
		        if(isset($matches[1])){
		        	$data['fc_server_host'] = $matches[1];			        	
		        }else{
		        	$data['fc_server_host'] = '';
		        }
	        }
	        //server port
	        preg_match('/init_port = ([0-9]*);/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port'] = $matches[1];			        	
	        }else{
	        	$data['fc_server_port'] = '';
	        }
	        //server host s
			preg_match('/init_host_s = "([a-zA-Z0-9.]*)";/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host_s'] = $matches[1];			        	
	        }else{
		        preg_match('/init_host_s="([a-zA-Z0-9.]*)";/', $content, $matches);
		        if(isset($matches[1])){
		        	$data['fc_server_host_s'] = $matches[1];			        	
		        }else{
		        	$data['fc_server_host_s'] = '';
		        }
	        }
	        //server port s
	        preg_match('/init_port_s = ([0-9]*);/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port_s'] = $matches[1];			        	
	        }else{
	        	$data['fc_server_port_s'] = '';
	        }
	        //server host h
			preg_match('/init_host_h = "([a-zA-Z0-9.]*)";/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host_h'] = $matches[1];			        	
	        }else{
		        preg_match('/init_host_h="([a-zA-Z0-9.]*)";/', $content, $matches);
		        if(isset($matches[1])){
		        	$data['fc_server_host_h'] = $matches[1];			        	
		        }else{
		        	$data['fc_server_host_h'] = '';
		        }
	        }
	        //server port h
	        preg_match('/init_port_h = ([0-9]*);/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port_h'] = $matches[1];			        	
	        }else{
	        	$data['fc_server_port_h'] = '';
	        }
	        return $data;
	    }else{
	    	return false;
	    }
	}
	
	public function getServerHostPortHost($client_location){
		$content = topcmmRequestRemote::requestRemote($client_location,1);
		if ($content){
			//server port
			preg_match('/init_port=([0-9]*)/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port'] = $matches[1];			        	
	        }
	        //server port s
			preg_match('/init_port_s=([0-9]*)/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port_s'] = $matches[1];			        	
	        }
	        //server port h
			preg_match('/init_port_h=([0-9]*)/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port_h'] = $matches[1];			        	
	        }
	        //server host
			preg_match('/init_host=([a-zA-Z0-9.]*)/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host'] = $matches[1];			        	
	        }
	        //server host s
			preg_match('/init_host_s=([a-zA-Z0-9.]*)&/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host_s'] = $matches[1];			        	
	        }
	        //server host h
			preg_match('/init_host_h=([a-zA-Z0-9.]*)&/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host_h'] = $matches[1];			        	
	        }
	        return $data;
	    }else{
            return false;
	    }
	}    
}


?>